#include <dc_motor.h>
#include "stm32f4xx.h"

void dc_motor_init(void)
	{
	const int AF02=0x02;

	RCC->AHB1ENR	|=	RCC_AHB1ENR_GPIOAEN;
	GPIOA->MODER	|=	GPIO_MODER_MODE0_1;
	GPIOA->MODER	&= ~GPIO_MODER_MODE0_0;
	GPIOA->AFR[0] |= (AF02<<0);
	RCC->APB1ENR  |=  RCC_APB1ENR_TIM5EN;
	TIM5->CR1     &=~ TIM_CR1_CEN;
	TIM5->CCMR1|=TIM_CCMR1_OC1M_2|TIM_CCMR1_OC1M_1;
	TIM5->CCER|=TIM_CCER_CC1E;
	TIM5->PSC=10;
	TIM5->ARR=1000;
	TIM5->CCR1=0;
	TIM5->CR1|= TIM_CR1_CEN;
	}

void set_duty_cycle(uint32_t duty)
	{
	uint32_t max_duty=TIM5->ARR;
	if(duty>max_duty){duty=max_duty;}
	TIM5->CCR1=duty;
	}
